#! /usr/bin/env python

# 2005-02-06    initial version    hp

import sys
from qt import *
from qttable import *

class TableWithColor(QTable):
    def __init__(self, numRows, numCols, parent, name = None):
        QTable.__init__(self, numRows, numCols, parent, name)
        self._cellColor = {}

    def setCellColor(self, row, col, color):
        if color == None or color == Qt.black:
            try:
                del self._cellColor[(row, col)]
            except KeyError:
                pass
        else:
            self._cellColor[(row,col)] = color

    def cellColor(self, row, col):
        return self._cellColor.get((row,col), Qt.black)

    def paintCell(self, p, row, col, cr, selected, cg = None):
        if cg:
            myc = QColorGroup(cg)
            myc.setColor(QColorGroup.Text, self.cellColor(row, col))
            QTable.paintCell(self, p, row, col, cr, selected, myc)
        else:
            QTable.paintCell(self, p, row, col, cr, selected)


if __name__ == '__main__':
    app = QApplication(sys.argv)
    table = TableWithColor(8, 4, None)
    table.setText(0, 0, "black")
    table.setText(2, 2, "red")
    table.setCellColor(2, 2, Qt.red)
    table.setText(5, 2, "blue")
    table.setCellColor(5, 2, Qt.blue)
    table.show()
    QObject.connect(qApp, SIGNAL("lastWindowClosed()"), qApp, SLOT("quit()"))
    app.exec_loop()
